// Encoding: ISO-8859-2
// enum.c
// een IJC-DU1, pklad a), 18.3.2010
// Autor: Milan Falenk, FIT, xfales01@stud.fit.vutbr.cz
// Peloeno: gcc 4.4.5 x86-64, Xubuntu linux
// Pouvm vce tabulek s variantami, ne to pepotvat
#include "enum.h"
#include "error.h"
#include <string.h>
#include <ctype.h>

#define MES_MIN 1
#define MES_MAX 12
#define SHORT_LENGTH 3

// Dlouhe bez diakritiky
static const char *cesky[] = {"ChybnyMesic", "Leden", "Unor", "Brezen", "Duben", "Kveten", "Cerven", "Cervenec", "Srpen", "Zari", "Rijen", "Listopad", "Prosinec"};
// dlouhe s diakritikou
static const char *czesky[] = {"ChybnMsc", "Leden", "nor", "Bezen", "Duben", "Kvten", "erven", "ervenec", "Srpen", "Z", "jen", "Listopad", "Prosinec"};
// kratke bez diakritiky
static const char *ceskyKr[] = {"Chy", "Led", "Uno", "Bre", "Dub", "Kve", "Cen", "Cec", "Srp", "Zar", "Rij", "Lis", "Pro"};
// kratke s diakritikou
static const char *czeskyKr[] = {"Chy", "Led", "no", "Be", "Dub", "Kv", "en", "ec", "Srp", "Z", "j", "Lis", "Pro"};


// kontroluje rozsah mesicu
void dcheck(enum months d)
{
	if(d < MES_MIN || d > MES_MAX)
		Error("PrintMonth*: Hodnota %d je mimo rozsah\n", d);
}

void PrintMonthShort(enum months d)
{
	dcheck(d);
	
	printf("%s", czeskyKr[d]);
	return;
}

void PrintMonth(enum months d)
{
	dcheck(d);
	
	printf("%s", czesky[d]);
	
	return;
}

enum months ReadMonth(void)
{
	const int AR_MAX = 16;	// Vic jak 16 nacitat nebudeme
	char read[AR_MAX+1];
	int pos = 0;
	int c;
	
	while( (c = getchar()) != EOF )
	{
		if(isspace(c) && pos == 0)
			continue; // prazdne znaky
		else if(isspace(c) && pos > 0)
			break; // finito
		else if(isalpha(c) && pos == AR_MAX)
			break; // finito, ale stejne je nactena blbost, protoze zadny mesic nemame na 16 :)
		
		if(isalpha(c)) // pokud je to alfanumericky znak
		{
			read[pos] = (pos > 0) ? tolower(c) : toupper(c);	// Prevedeme na pozadovanou velikost pismen
			read[++pos] = '\0';	// a na konec vzdycky soupneme nulu
		}
		else
			break;	// Nacetli jsme blbost, tak to stopneme
		
	}
	
	if(pos < SHORT_LENGTH)
		Error("ReadMonth*: Pli krtk zadn!");	// Mene jak 3
	
	for(int i = 1; i <= MES_MAX; i++)	// Iterujeme pres mesice
		if(strcmp(read, cesky[i]) == 0 || strcmp(read, czesky[i]) == 0 || strcmp(read, ceskyKr[i]) == 0 || strcmp(read, czeskyKr[i]) == 0) // a kontrolujeme, zda neni shoda
			return i;
	
	return ChybnyMesic;
}
